/*********************************************************************
 *                    Flowcode Custom Component Code
 *
 * File: Custom_Code.c
 *
 * (c) 2007 Matrix Multimedia Ltd.
 * http://www.matrixmultimedia.com
 *
 * Software License Agreement
 *
 * The software supplied herewith by Matrix Multimedia Ltd (the
 * Company) for its Flowcode graphical programming language is
 * intended and supplied to you, the Company's customer, for use
 * solely and exclusively on the Company's products. The software
 * is owned by the Company, and is protected under applicable
 * copyright laws. All rights are reserved. Any use in violation
 * of the foregoing restrictions may subject the user to criminal
 * sanctions under applicable laws, as well as to civil liability
 * for the breach of the terms and conditions of this licence.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * Changelog:
 *
 *  date  | by | description
 * -------+----+-----------------------------------------------------
 * 240407 | ST | Created
 *        |    |
 *        |    |
 *        |    |
 *        |    |
 *
 *
 *
 ********************************************************************/

/*********************************************************************

 Return & parameter types:
   void
   char
   short
   char*

 Pin directions:
   0 = OUTPUT
   2 = INPUT
   3 = BIDIRECTIONAL

 Macro substitutions:
   %a = ??
   %b = ??
   %c = ??
   %d = %d
   %e = ??
   %f = ??
   %g = ??
   %h = ??
   %i = ??
   %j = ??

**********************************************************************

[Settings]
CLSID={4B174520-75AB-4B14-A0F7-2AA6C203F1DC}
IsAnalogue=0
MultipleAllowed=0
Description=Custom Flowcode Component

**********************************************************************

[Port]
DesiredPort=0
PortMandatory=0
SamePortAsID=0

[Pins]
Count=0

[PinPort]
# PORTA = 0
# PORTB = 1
# PORTC = 2
# PORTD = 3
# PORTE = 4

[PinDesiredBit]

[PinDirection]
# DIR_INPUT = 2
# DIR_OUTPUT = 0
# DIR_BIDIRECTIONAL = 3

[PinMustUsePort]
# boolean

[SamePortAsPinX]
# -1 = any pin
# otherwise, the pin number

[PinMustUsePin]
# boolean

[PinValue]
# boolean (0 = off, 1 = on)

**********************************************************************

[MacroNames]
Count=2
1=GetDefines
2=TestWave


[MacroReturns]
1=void
2=void

[MacroIsPrivate]
1=1
2=0


[MacroParameters_GetDefines]
Count=0

[MacroParamTypes_GetDefines]


[MacroParameters_TestWave]
Count=0

[MacroParamTypes_TestWave]
*************************************/

/********************************************************************
 * ADDITIONAL CODE
 ********************************************************************/

/*InitialisationCode_Start*/
/*InitialisationCode_End*/

/*InterruptCode_Start*/
/*InterruptCode_End*/




/********************************************************************
 * FUNCTIONS
 ********************************************************************/


void GetDefines(){
/*Macro_GetDefines_Start*/

}  //Dummy end of function to allow defines to be added correctly

//common defines
#define MX_CUSTOM_1  %a
#define MX_CUSTOM_2  %b
#define MX_CUSTOM_3  %c
#define MX_CUSTOM_4  %d
#define MX_CUSTOM_5  %e
#define MX_CUSTOM_6  %f
#define MX_CUSTOM_7  %g
#define MX_CUSTOM_8  %h
#define MX_CUSTOM_9  %i
#define MX_CUSTOM_10 %j

// global Timer1Delta array
short asADC[1024];

// table for sine wave of the first arc from 0 to pi/2
// built with asin(x*(1/128))*1000 to avoid floating point; x E 0-127
unsigned char aSineWave[] = {0,
1,3,4,6,7,9,10,12,14,15,
17,18,20,21,23,24,26,28,29,31,
32,34,35,37,38,40,41,43,44,46,
47,48,50,51,53,54,56,57,58,60,
61,63,64,65,67,68,69,71,72,73,
74,76,77,78,79,81,82,83,84,85,
87,88,89,90,91,92,93,94,95,96,
97,98,99,100,101,102,103,104,105,106,
107,108,108,109,110,111,112,112,113,114,
115,115,116,117,117,118,118,119,119,120,
121,121,122,122,122,123,123,124,124,124,
125,125,125,126,126,126,126,127,127,127,
127,127,127,127,127,127,127};


// Dummy function to close the defines section off
void CUSTOM_Dummy_Function();
void CUSTOM_Dummy_Function(){

/*Macro_GetDefines_End*/
}

void TestWave(){
/*Macro_TestWave_Start*/
	int i;
	extern unsigned char aSineWave[];
	unsigned char tmp;
	for(i=0;i<=127;i++){
		tmp = 128 + aSineWave[i];
		//tmp = 128 + i;
		FCD_LCDDisplay0_PrintNumber(tmp);
		delay_ms(255);
		FCD_LCDDisplay0_Cursor(0, 0);	
	}
/*Macro_TestWave_End*/
}
